#include "oath/characterSet.h"

#include "timer.h"

#include <iostream.h>

/////////////////////////////////////////////////////////////////////////////
// Test of characters and tokens

main ()
   {// Test Characters ////////////////////

    characterA A = characterA::make('A');
    characterA B = characterA::make('b');
    characterA Y = characterA::make('Y');
    characterA Z = characterA::make('z');

    characterA Zero = characterA::make('0');
    characterA One  = characterA::make('1');
    characterA Nine = characterA::make('9');

    characterA Bang = characterA::make('!');
    characterA Star = characterA::make('*');
    characterA US   = characterA::make('_');
    characterA Dash = characterA::make('-');

    // Character Sets /////////////////////

    characterSetA IdChar     = characterSetA::make("A-Za-z0-9_");
    characterSetA NotIdChar  = characterSetA::make("^A-Za-z0-9_");
    characterSetA Printables = characterSetA::make("A-Za-z0-9_!@#$%^&*()-");

    // Functionality Test ////////////////////

    if(IdChar.contains(A) && IdChar.contains(B) && IdChar.contains(Y)
			  && IdChar.contains(Z) && IdChar.contains(US)
			  && IdChar.contains(Zero) && IdChar.contains(One)
			  && IdChar.contains(Nine))
        cout << "Success 1" << endl;
    else
        cout << "Fail 1" << endl;

    if(IdChar.contains(Bang) || IdChar.contains(Star) || IdChar.contains(Dash))
        cout << "Fail 2" << endl;
    else
        cout << "Success 2" << endl;


    if(NotIdChar.contains(A) || NotIdChar.contains(B) || NotIdChar.contains(Y)
			     || NotIdChar.contains(Z) || NotIdChar.contains(US)
			     || NotIdChar.contains(Zero)
			     || NotIdChar.contains(One)
			     || NotIdChar.contains(Nine))
        cout << "Fail 3" << endl;
    else
        cout << "Success 3" << endl;

    if(NotIdChar.contains(Bang) && NotIdChar.contains(Star)
				&& NotIdChar.contains(Dash))
        cout << "Success 4" << endl;
    else
        cout << "Fail 4" << endl;


    if(Printables.contains(A) && Printables.contains(B) 
			      && Printables.contains(Y)
			      && Printables.contains(Z) 
			      && Printables.contains(US)
			      && Printables.contains(Zero) 
			      && Printables.contains(One)
			      && Printables.contains(Nine)
			      && Printables.contains(Bang) 
			      && Printables.contains(Star)
			      && Printables.contains(Dash))
        cout << "Success 5" << endl;
    else
        cout << "Fail 5" << endl;

    // Speed Test ////////////////////

    timer Timer;
    int Count = 0;

    Timer.start();
    for(int I = 0; I < 100000; ++I)
       {if(IdChar.contains(A) && IdChar.contains(B) && IdChar.contains(Y)
			      && IdChar.contains(Z) && IdChar.contains(US)
			      && IdChar.contains(Zero) && IdChar.contains(One)
			      && IdChar.contains(Nine))
            ++Count;
       }
    Timer.split();

    cout << "Count should be 100000: " << Count << endl;
    cout << "Time to process 100000*8 contains calls:" << endl
	 << "\tReal Time = " << Timer.real() << " ms" << endl
	 << "\t CPU Time = " << Timer.cpu() << " ms" << endl;

   }


